#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################


#use FindBin;
#use lib $FindBin::Bin;
use DBI;
use CGI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;


##########

print "Content-type: text/html\n\n"; 

## REMOVE OLD FILES IF ANY LEFT
opendir(DIR,"$data_dir");
@files = readdir(DIR);

foreach $filename (@files)
	{

	if (substr($filename, length($filename) - 3, 3) eq "llc")
		{
		unlink ("$data_dir/$filename");
		}
		elsif (substr($filename, length($filename) - 5, 5) eq "lclog")
		{
		unlink ("$data_dir/$filename");
		}
		elsif (substr($filename, length($filename) - 5, 5) eq "lcpid")
		{
		unlink ("$data_dir/$filename");
		}
		elsif (substr($filename, length($filename) - 6, 6) eq "lclog2")
		{
		unlink ("$data_dir/$filename");
		}
		
	}
closedir (DIR);

#######



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }


if ($q->param('ids') ne "")
	{
	@allc = split (/,/, $q->param('ids'));
	
	foreach $citem (@allc)
		{
			if ($citem > 0)
				{
				$csql = $csql . "(cid = '" . int($citem) . "') OR ";
				}
			
		}
		
		$csql = substr($csql, 0, length($csql) - 3);
		$csql = "WHERE " . $csql;
		$sql = "SELECT lnkid, cid, url FROM links $csql";
	}
	else
	{
	$sql = "SELECT lnkid, cid, url FROM links";
	}
	
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
$rows = $sth->rows(); 

if ($rows < 1) { acs::problem_popup("No links available for the category ID(s) you specified."); exit;}
 

$cconf = acs::get_file_contents("$data_dir/crawler.cfg");  
($ver, $links_to_check_per_window, $frames, $timeout) = split (/\n/, $cconf);



if ($frames eq "") { $frames = 10; }

$nr_segments = $frames;



$modp = ($rows / $nr_segments);


if ($modp =~ /\./)
	{
	($perfile, $tmp) = split(/\./, $modp);
	}
	else
	{
	$perfile = $modp;
	}

$perfile = $perfile + 10;

$pcount = 0;
$fcount = 1;


while ( @row = $sth->fetchrow() )
	{
	$lnr = $lnr . $row[0] . ":-:-:" . $row[1] . ":-:-:" . $row[2] . "\n"; 
	$pcount++;

	if ($pcount == $perfile)
		{
		open (FWR, "> $data_dir/$fcount.llc");
			print FWR $lnr;
		close (FWR);
		$lnr = "";
		$pcount = 0;
		$fcount++;
		}
	
	}

## WRITE REMAINING LINKS
open (FWR, "> $data_dir/$fcount.llc");
	print FWR $lnr;
close (FWR);

###########

#print "NUMBER OF FILES: $fcount <BR>";
#print "TOTAL LINKS: $rows <BR>";


$sth->finish;
$dbh->disconnect;


### CONSTRUCT WINDOW


$hbox = acs::get_heading_box("$web_url/ic_task.gif", "Broken Link Checker", qq[
Total Number of links to check: <b>$rows</b><BR>
<font color="#FF0000"><b>Please wait untill each window below indicates that all links for the thread has been checked....</b></font><BR>
You may <a href="$admin_url/admin58.cgi?fct=lchecker">click here</a> to manage reported broken links that has been found by the 'Broken Link Checker' after all threads has finished.
]);




print qq[

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body>

$hbox
];


for ($ms = 1; $ms <= $nr_segments; $ms++)  
	{
	print qq[
	<font face="Verdana" size="1"><b>Thread $ms:</b></font><BR><BR>
	<iframe src="$admin_url/linkchecker4.cgi?fname=$ms" width="100%" height="200"></iframe>
	<BR><BR>
	];
	}


print qq[</body></html>];


#####################################








sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################



sub get_env
{
if ($ENV{'QUERY_STRING'} ne "") {
								$temp = $ENV{'QUERY_STRING'};
								}
								else
								{
								read(STDIN, $temp, $ENV{'CONTENT_LENGTH'});
								}

@pairs=split(/&/,$temp);
foreach $item(@pairs){
	($key,$content)=split (/=/,$item,2);
	$content=~tr/+/ /;
	$content=~ s/%(..)/pack("c",hex($1))/ge;
	$fields{$key}=$content;}

}
 